import React, { useState } from 'react';
import { v4 as uuid } from 'uuid';


export function getCurrentUser() {
    let userName = "";
    let id = "";
    const savedUUID = localStorage.getItem("uuid");
    const signedIn = localStorage.getItem("signedIn");
    
    if (!signedIn) {
        userName = "Anonymous";
    } else {
        userName = localStorage.getItem("username");
    }

    if (savedUUID == null) {
        id = uuid();
        localStorage.setItem("uuid", JSON.stringify(id));
    } else {
        id = JSON.parse(savedUUID);
    }

    return {
        name: userName,
        uuid: id,
        signedIn: signedIn ? "true" : "false",
    };
}

const SmallUserDetail = () => {
    const [user, setUser] = useState(getCurrentUser());

    return (
        <div>
            <div>
                {user.name}
            </div>
            <div>
                {user.uuid}
            </div>
        </div>
    )
};

export default SmallUserDetail