// import React from 'react';
// import ReactDOM from 'react-dom';
// import { Provider } from 'react-redux'
// import './index.css';
// import App from './App';
// // import * as serviceWorker from './serviceWorker';
// import { createStore } from './store'
// import Backendless from 'backendless'
// Backendless.initApp('2481D6B7-AECB-159C-FF68-532BD923E600', 'BEEC2158-C72E-4B80-98B4-24D156C3D732');
// const rootElement = document.getElementById('root');
// ReactDOM.render(
// <Provider store={createStore()}>
//   <App/>
// </Provider>,
// rootElement
// )

// If you want your app to work offline and load faster, you can change
// unregister() to register() below. Note this comes with some pitfalls.
// Learn more about service workers: https://bit.ly/CRA-PWA
// serviceWorker.unregister();

import ReactDOM from "react-dom/client";
import { BrowserRouter, Routes, Route } from "react-router-dom";
import NoPage from "./pages/NoPage";

import ButtonStart, {DelayStart, NoButtonStart} from "./pages/ButtonStart";
import Timer, {QRStopButtonTimer} from "./pages/Timer";
import Finish, {RedirectFinish} from "./pages/Finish";
import HomePage from "./pages/HomePage";
import WaitForQr from "./pages/WaitForQr";
import Backendless from 'backendless'


export default function RunTheStairs() {

  return (
    <BrowserRouter>
      <Routes>
        <Route path="/newRun-QRStart-InstaFinish" element={<NoButtonStart timer="/timer" finishUrl="/save-result" waitForQr={false}/>} />
        <Route path="/newRun-QRStart-QRFinish" element={<NoButtonStart timer="/timer" finishUrl="/waitForQr" waitForQr={true}/>} />
        <Route path="/newRun-QRStart-OnlyQRFinish" element={<NoButtonStart timer="/onlyQrtimer" finishUrl="/waitForQr" waitForQr={true}/>} />
        <Route path="/newRun-ButtonStart-InstaFinish" element={<ButtonStart timer="/timer" finishUrl="/save-result" waitForQr={false}/>} />
        <Route path="/newRun-ButtonStart-QRFinish" element={<ButtonStart timer="/timer" finishUrl="/waitForQr" waitForQr={true}/>} />
        <Route path="/newRun-ButtonStart-OnlyQRFinish" element={<ButtonStart timer="/onlyQrtimer" finishUrl="/waitForQr" waitForQr={true}/>} />
        <Route path="/newRun-DelayStart-InstaFinish" element={<DelayStart timer="/timer" finishUrl="/save-result" waitForQr={false}/>} />
        <Route path="/newRun-DelayStart-QRFinish" element={<DelayStart timer="/timer" finishUrl="/waitForQr" waitForQr={true}/>} />
        <Route path="/newRun-DelayStart-OnlyQRFinish" element={<DelayStart timer="/onlyQrtimer" finishUrl="/waitForQr" waitForQr={true}/>} />
        <Route path="/waitForQr" element={<WaitForQr />} />
        <Route path="/timer" element={<Timer />} />
        <Route path="/onlyQrtimer" element={<QRStopButtonTimer />} />
        <Route path="/save-result" element={<RedirectFinish />} />
        <Route path="/finish" element={<Finish />} />
        <Route path="/" element={<HomePage />}>
          <Route path="*" element={<NoPage />} />
        </Route>
      </Routes>
    </BrowserRouter>
  );
}


Backendless.initApp('2481D6B7-AECB-159C-FF68-532BD923E600', 'BEEC2158-C72E-4B80-98B4-24D156C3D732');

const root = ReactDOM.createRoot(document.getElementById('root'));
root.render(<RunTheStairs />);
