import React, { useEffect, useState } from 'react';
import { useNavigate } from 'react-router-dom';
import { getCurrentUser } from '../Components/SmallUserDetail';
import '../style/button.css'
import '../style/generic.css'

const ButtonStart = (props) => {
    getCurrentUser();
    const navigate = useNavigate();
    return (
        <div className="container">
            <div className="containerChild">
                <button className="button" onClick={() => navigate(props.timer, {state:{finishUrl: props.finishUrl, waitForQr: props.waitForQr}})}>Start</button>
            </div>
        </div>
    );
}

export const DelayStart = (props) => {
    getCurrentUser();
    const navigate = useNavigate();

    const [timeLeft, setTimeLeft] = useState(null);

    useEffect(() => {
        if(timeLeft===0){
            navigate(props.timer, {state:{finishUrl: props.finishUrl, waitForQr: props.waitForQr}});
        }
        if (!timeLeft) {
            return;
        }

        const intervalId = setInterval(() => {
            setTimeLeft(timeLeft - 1);
        }, 1000);
        return () => clearInterval(intervalId);
    }, [timeLeft]);

    
    return (
        <div className="container">
            <div className="containerChild">
                <button className="button" onClick={() => {setTimeLeft(3)}}>{timeLeft === null ? "Start after 3 seconds" : timeLeft}</button>
            </div>
        </div>
    );
}

export const NoButtonStart = (props) => {
    const navigate = useNavigate();
    useEffect(() => {
        navigate(props.timer, {state: {
            finishUrl: props.finishUrl, 
            waitForQr: props.waitForQr
        }})
    });
    return (
        <div></div>
    );
}

export default ButtonStart;