import React, { useEffect, useState } from 'react';
import { useNavigate } from 'react-router-dom';
import { getCurrentUser } from '../Components/SmallUserDetail';
import TimeGraph from '../Components/TimeGraph';

import Backendless from 'backendless';

const getTime = () => {
    return {
        mil: localStorage.getItem("miliseconds"),
        sec: localStorage.getItem("seconds"),
        min: localStorage.getItem("minutes")
    };
}

function findPersonName(people) {
    const savedUUID = localStorage.getItem("uuid");
    for (let i = 0; i < people.length; i++) {
        if ("\"" + people[i].uuid + "\"" == savedUUID) {
            localStorage.setItem("signedIn", JSON.stringify("true"));
            localStorage.setItem("username", JSON.stringify(people[i].name));
            return people[i].name;
        }
    }
    return ""
}

function saveTime(user) {
    const time = getTime();
    Backendless.Data.of( "Times" ).save( {
        time: parseInt(time.min) * 60 * 1000 + parseInt(time.sec) * 1000 + parseInt(time.mil),
        uuid: user.uuid
    } );
}

function addUser(user) {
    Backendless.Data.of( "Person" ).save( {
        name: user.name,
        uuid: user.uuid
    } );
}

export const RedirectFinish = (props) => {
    const [user, setUser] = useState(getCurrentUser());
    
    const navigate = useNavigate();
    useEffect(() => {
        saveTime(user);
        navigate('/finish')
    });
    return (
        <div></div>
    );
}

const Finish = () => {
    const [user, setUser] = useState(getCurrentUser());
    const {mil, sec, min} = getTime();

    const people = Backendless.Data.of('Person').find();
    const [newusername, setNewUserName] = useState("");
    people.then(people => {
        const username = findPersonName(people)
        if (username === "") {
            setUser({
                name: "Anonymous",
                uuid: user.uuid,
                signedIn: "false"
            });
        } else {
            setUser({
                name: username,
                uuid: user.uuid,
                signedIn: "true"
            });
        }
    });

    
    console.log(user);

    return (
        <div className="App">
            <h1>FINISH</h1>
            
            <div>
                <p>TIME</p>
                <p>{min < 10 ? "0" + min : min}:{sec < 10 ? "0" + sec : sec}:{mil < 100 ? "0" + mil : mil >= 1000 ? "999" : mil}</p>
            </div>
            {user.signedIn === "true" ? 
                <p>{user.name}</p> :
                <div>
                    <input onChange={(e) => setNewUserName(e.target.value)}/>
                    <button onClick={() => {addUser({
                        name: newusername,
                        uuid: user.uuid
                    }); localStorage.setItem("signedIn", "true")}}>Add user</button>
                </div>
            }
            
            <TimeGraph />
        </div>
    );
}

export default Finish;