import React, { useState, useEffect } from 'react';
import { useLocation, useNavigate } from 'react-router-dom';
import Html5QrcodePlugin from '../Components/Html5QrcodePlugin';

export const QRStopButtonTimer = () => {
  const locationState = useLocation().state;

  const [miliSeconds, setMiliSeconds] = useState(0);
  const [seconds, setSeconds] = useState(0);
  const [minutes, setMinutes] = useState(0);

  var timer;
  useEffect(() => {
      timer = setInterval(() => {
          setMiliSeconds(miliSeconds + 10);
          if (miliSeconds === 1000) {   
              setSeconds(seconds + 1);
              setMiliSeconds(0);
          }
  
          if (seconds === 60) {
              setMinutes(minutes + 1);
              setSeconds(0);
          }
          saveTime();
      }, 10)
      return () => clearInterval(timer);
  });

  const saveTime = () => {
    localStorage.setItem("miliseconds", JSON.stringify(miliSeconds));
    localStorage.setItem("seconds", JSON.stringify(seconds));
    localStorage.setItem("minutes", JSON.stringify(minutes));
  }

  const navigate = useNavigate();

  const onNewScanResult = (decodedText, decodedResult) => {
    saveTime();
    navigate(decodedText, {state: { time: {mil:miliSeconds, sec:seconds, min:minutes}, waitForQr: locationState.waitForQr }});
  }

  return (
    <div className="timer">
      <div className="container">
        <div className="timer_container">
            <h1>Timer</h1>
            <p>{minutes < 10 ? "0" + minutes : minutes}:{seconds < 10 ? "0" + seconds : seconds}:{miliSeconds < 100 ? "0" + miliSeconds : miliSeconds >= 1000 ? "999" : miliSeconds}</p>
            <Html5QrcodePlugin 
                fps={10}
                qrbox={250}
                disableFlip={false}
                qrCodeSuccessCallback={onNewScanResult}/>
        </div>
      </div>
    </div>
  );
}

const Timer = (props) => {
  const [miliSeconds, setMiliSeconds] = useState(0);
  const [seconds, setSeconds] = useState(0);
  const [minutes, setMinutes] = useState(0);

  const locationState = useLocation().state;

  var timer;
  useEffect(() => {
      timer = setInterval(() => {
          setMiliSeconds(miliSeconds + 10);
          if (miliSeconds === 1000) {   
              setSeconds(seconds + 1);
              setMiliSeconds(0);
          }
  
          if (seconds === 60) {
              setMinutes(minutes + 1);
              setSeconds(0);
          }
      }, 10)
      return () => clearInterval(timer);
  });

  const saveTime = () => {
    localStorage.setItem("miliseconds", JSON.stringify(miliSeconds));
    localStorage.setItem("seconds", JSON.stringify(seconds));
    localStorage.setItem("minutes", JSON.stringify(minutes));
  }

  const navigate = useNavigate();

  return (
    <div className="timer">
      <div className="container">
        <div className="timer_container">
            <h1>Timer</h1>
            <p>{minutes < 10 ? "0" + minutes : minutes}:{seconds < 10 ? "0" + seconds : seconds}:{miliSeconds < 100 ? "0" + miliSeconds : miliSeconds >= 1000 ? "999" : miliSeconds}</p>
            
            <button onClick={() => {saveTime(); navigate(locationState.finishUrl, {state: { time: {mil:miliSeconds, sec:seconds, min:minutes}, waitForQr: locationState.waitForQr }})}}>Stop</button>
        </div>
      </div>
    </div>
  );
}

export default Timer;